Loading...
Searching...
No Matches
juce::AudioProcessorParameterWithID Class Reference

## Detailed Description

This abstract base class is used by some AudioProcessorParameter helper classes.

See also
  AudioParameterFloat, AudioParameterInt, AudioParameterBool, AudioParameterChoice

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/utilities/juce_AudioProcessorParameterWithID.h

Inheritance diagram for juce::AudioProcessorParameterWithID:

## Public Member Functions

| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from juce::HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from juce::AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
virtual float | getValue () const =0
| Called by the host to find out the value of this parameter.
virtual void | setValue (float newValue)=0
| The host will call this method to change the value of a parameter.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
virtual float | getDefaultValue () const =0
| This should return the default value for this parameter.
virtual int | getNumSteps () const
| Returns the number of steps that this parameter's range should be quantised into.
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.
virtual String | getText (float normalisedValue, int) const
| Returns a textual version of the supplied normalised parameter value.
virtual float | getValueForText (const String &text) const =0
| Should parse a string and return the appropriate value for it.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
void | setParameterIndex (int) noexcept
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | setOwner (Listener *listener) noexcept
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Public Attributes

const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Additional Inherited Members

Public Types inherited from juce::AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Static Public Member Functions inherited from juce::AudioProcessorParameter
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.

## Constructors and Destructors

## AudioProcessorParameterWithID() [1/2]

juce::AudioProcessorParameterWithID::AudioProcessorParameterWithID | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | const AudioProcessorParameterWithIDAttributes & | attributes = {} )

The creation of this object requires providing a name and ID which will be constant for its lifetime.

Given that AudioProcessorParameterWithID is abstract, you'll probably call this constructor from a derived class constructor, e.g.

MyParameterType (String paramID, String name, String label, bool automatable)
: AudioProcessorParameterWithID (paramID, name, AudioProcessorParameterWithIDAttributes().withLabel (label)
.withAutomatable (automatable))
{
}
juce::AudioProcessorParameterWithIDAttributes
An instance of this class may be passed to the constructor of an AudioProcessorParameterWithID to set...
Definition juce_AudioProcessorParameterWithID.h:80
juce::AudioProcessorParameterWithID::label
const String label
Provides access to the parameter's label.
Definition juce_AudioProcessorParameterWithID.h:180
juce::AudioProcessorParameterWithID::name
const String name
Provides access to the parameter's name.
Definition juce_AudioProcessorParameterWithID.h:177
juce::AudioProcessorParameterWithID::AudioProcessorParameterWithID
AudioProcessorParameterWithID(const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
The creation of this object requires providing a name and ID which will be constant for its lifetime.
juce::AudioProcessorParameterWithID::paramID
const String paramID
Provides access to the parameter's ID string.
Definition juce_AudioProcessorParameterWithID.h:174
juce::String
The JUCE String class!
Definition juce_String.h:67

Parameters

  parameterID | Specifies the identifier, and optionally the parameter's version hint.
  parameterName | The user-facing parameter name.
  attributes | Other parameter properties.

Referenced by AudioProcessorParameterWithID().

## AudioProcessorParameterWithID() [2/2]

juce::AudioProcessorParameterWithID::AudioProcessorParameterWithID | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | const String & | parameterLabel,
|  | Category | parameterCategory = AudioProcessorParameter::genericParameter )

inline

The creation of this object requires providing a name and ID which will be constant for its lifetime.

Parameters

  parameterID | Used to uniquely identify the parameter
  parameterName | The user-facing name of the parameter
  parameterLabel | An optional label for the parameter's value
  parameterCategory | The semantics of this parameter

References AudioProcessorParameterWithID(), and juce::AudioProcessorParameter::genericParameter.

## Member Functions

## getName()

String juce::AudioProcessorParameterWithID::getName | ( | int | maximumStringLength | ) | const

override virtual

Returns the name to display for this parameter, which should be made to fit within the given string length.

Implements juce::AudioProcessorParameter.

## getLabel()

String juce::AudioProcessorParameterWithID::getLabel | ( |  | ) | const

override virtual

Some parameters may be able to return a label string for their units.

For example "Hz" or "%".

Implements juce::AudioProcessorParameter.

## getCategory()

Category juce::AudioProcessorParameterWithID::getCategory | ( |  | ) | const

override virtual

Returns the parameter's category.

Reimplemented from juce::AudioProcessorParameter.

## getParameterID()

String juce::AudioProcessorParameterWithID::getParameterID | ( |  | ) | const

inline override virtual

Returns an ID that is unique to this parameter.

Parameter indices are unstable across plugin versions, which means that the parameter found at a particular index in one version of a plugin might move to a different index in the subsequent version.

Unlike the parameter index, the ID returned by this function should be somewhat stable (depending on the format of the plugin), so it is more suitable for storing/recalling automation data.

Implements juce::HostedAudioProcessorParameter.

References paramID.

## isMetaParameter()

bool juce::AudioProcessorParameterWithID::isMetaParameter | ( |  | ) | const

inline override virtual

Should return true if this parameter is a "meta" parameter.

A meta-parameter is a parameter that changes other params. It is used by some hosts (e.g. AudioUnit hosts). By default this returns false.

Reimplemented from juce::AudioProcessorParameter.

Referenced by juce::AudioProcessorValueTreeState::Parameter::Parameter().

## isAutomatable()

bool juce::AudioProcessorParameterWithID::isAutomatable | ( |  | ) | const

inline override virtual

Returns true if the host can automate this parameter.

By default, this returns true.

Reimplemented from juce::AudioProcessorParameter.

## isOrientationInverted()

bool juce::AudioProcessorParameterWithID::isOrientationInverted | ( |  | ) | const

inline override virtual

This can be overridden to tell the host that this parameter operates in the reverse direction.

(Not all plugin formats or hosts will actually use this information).

Reimplemented from juce::AudioProcessorParameter.

## Member Data Documentation

## paramID

const String juce::AudioProcessorParameterWithID::paramID

Provides access to the parameter's ID string.

Referenced by getParameterID().

## name

const String juce::AudioProcessorParameterWithID::name

Provides access to the parameter's name.

## label

const String juce::AudioProcessorParameterWithID::label

Provides access to the parameter's label.

## category

const Category juce::AudioProcessorParameterWithID::category

Provides access to the parameter's category.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited